Option Strict Off
Option Explicit On
Friend Class frmMain
	Inherits System.Windows.Forms.Form
	' *****************************************************************
	' *                                                               *
	' *       Copyright (c) Fast Corporation, 2007                    *
	' *                                                               *
	' *   All Rights Reserved.  Unpublished rights  reserved  under   *
	' *   the copyright laws of the Japan.                            *
	' *                                                               *
	' *   The software contained on this media  is  proprietary  to   *
	' *   and  embodies  the  confidential  technology  of  Fast      *
	' *   Corporation.  Possession, use,  duplication  or             *
	' *   dissemination of the software and media is authorized only  *
	' *   pursuant to a valid written license from Fast Corporation.  *
	' *                                                               *
	' *****************************************************************
	
	' -------------------------------------------------------------------
	' FVX Sample Program
	' C_CAO
	'
	' 쐬 : K.Yakushinji
	'
	'  : 2007/03/28 
    '        2012/02/13 FVC07Ή
	' -------------------------------------------------------------------
	
	'rfIfoCXI[vĂ邩
	Private m_blnVideoOpened As Boolean
	
	'rfIݒt@CitpXj
	Private m_strVideoConfFilePath As String
	
	't[ǂ
	Private m_intIsFreerun As Short
	
	'Lv`^Cv
	Private m_lngCaptureType As Integer
	
	Private m_time_min As Double
	Private m_time_max As Double
	Private m_count As Integer
	
	'AScope\؂ւ
	'UPGRADE_WARNING: Cxg chkAScope.CheckStateChanged ́AtH[ꂽƂɔ܂B ڍׂɂẮA'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"' NbNĂB
    Private Sub chkAScope_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        If chkAScope.CheckState = 1 Then
            FvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeAuto
        Else
            FvxDisplayEx1.AScopeMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ASCOPE_MODE.DISPLAYEX_AScopeDisable
        End If

    End Sub
	'GR[_[h
	'UPGRADE_WARNING: Cxg chkEncoder.CheckStateChanged ́AtH[ꂽƂɔ܂B ڍׂɂẮA'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"' NbNĂB
    Private Sub chkEncoder_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkEncoder.CheckedChanged

        If chkEncoder.CheckState = 1 Then
            fmEncoder.Enabled = True
        Else
            fmEncoder.Enabled = False
        End If

    End Sub
	
	'{\

	
	'tʕ\

	
	'\{plus

	
	'\{minus

	
	
	'SendSIO
    Private Sub cmdSendSio_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSendSio.Click
        Dim strRev As String
        Dim i As Integer
        Dim n As Short
        Dim lngErr As Integer


        On Error GoTo err_code

        FvxVideo1.SioOpen()
        txtReceive.Text = ""
        FvxVideo1.SendSioData(txtSendSio.Text, strRev, CInt(txtSioOption.Text))
        FvxVideo1.SioClose()

        For i = 1 To Len(strRev)
            n = Asc(Mid(strRev, i, 1))
            If ((&H0S <= n) And (n <= &H1FS)) Then
                txtReceive.Text = txtReceive.Text & "0x" & Hex(n) & " "
            Else
                txtReceive.Text = txtReceive.Text & Mid(strRev, i, 1)
            End If

        Next i

        Exit Sub

err_code:

        FvxVideo1.GetErrReport(lngErr)
        FvxVideo1.SioClose()
        If lngErr <> 0 Then
            MsgBox("SIOG[܂ : ErrorCode=" & CStr(lngErr), MsgBoxStyle.Exclamation, "Error")
        End If
    End Sub
	
	
	Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		
		Dim lngErr As Integer
		
		On Error Resume Next
		
		'rfIfoCX̃I[vԕێϐ̏
		m_blnVideoOpened = False
		cmdGrab.Enabled = False
		cmdFreerun.Enabled = False
		
		'C_CAO̕\
		Me.Show()
		
		'gp̊mF
		frmLicence.ShowDialog()
		
		'rfIfoCXI
		setVideoConfFile()
		
	End Sub
	
	Private Sub setVideoConfFile()
		
		Dim lngErr As Integer
		Dim lngCaptureType As Integer
		Dim lngCaptureNum As Integer
		Dim lngCaptureConnectorNum As Integer
		Dim i As Integer
		Dim lngTrg As Integer
		Dim lngExpTime As Integer
		Dim lngLine As Integer
		Dim lngEncoder As Integer
		Dim lngSignal As Integer
		Dim lngMlt As Integer
		Dim lngStart As Integer
		Dim lngPulse As Integer
		Dim lngComp1 As Integer
		Dim lngComp2 As Integer
		Dim lngInit As Integer
		Dim npMode As Integer
        Dim dblCycleTime As Double
        Dim lngExposureTime As Long
        Dim lngCntEnb As Long
        Dim lngMode As Long
        Dim lngSwapAB As Long
        Dim lngZEnb As Long
        Dim lngDelayTimeEnb As Long
        Dim lngCycleTimeEnb As Long
		
		On Error Resume Next
		
		If m_blnVideoOpened = True Then
			'rfIfoCXI[vĂꍇ͈UN[Y܂
			FvxVideo1.CloseDevice()
			'I[vtO𗎂
			m_blnVideoOpened = False
		End If
		
		'rfIݒt@C̑I
		frmSelectVideoConfFile.ShowDialog()
		m_strVideoConfFilePath = frmSelectVideoConfFile.strVideoConfFilePath
		
		If m_strVideoConfFilePath <> "" Then
			
			'rfIݒt@CR|[lgɐݒ
			FvxVideo1.VideoConfFile = m_strVideoConfFilePath
			'foCXI[v
			FvxVideo1.OpenDevice()
			FvxVideo1.GetErrReport(lngErr)
			If lngErr = 0 Then
				'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
				'̂߁AZbgAbv^CKvɂȂ܂
				Sleep(200)
				
				'Lv`{[h^Cv擾
				FvxVideo1.GetCaptureType(lngCaptureType)
				m_blnVideoOpened = False
				cmdGrab.Enabled = False
				cmdFreerun.Enabled = False

                If 10 = lngCaptureType Then

                    '[h擾
                    FvxVideo1.GetLineSensorMode(lngLine, lngEncoder)
                    Me.chkLineSensorMode.CheckState = lngLine
                    Me.chkEncoder.CheckState = lngEncoder
                    If chkEncoder.CheckState = 1 Then
                        fmEncoder.Enabled = True
                    Else
                        fmEncoder.Enabled = False
                    End If

                    'gK[hݒ
                    FvxVideo1.GetTrigger(lngTrg)

                    'IԎ擾
                    FvxVideo1.GetExposureTime(lngExposureTime)
                    Me.txtExposureTime.Text = CStr(lngExposureTime)

                    'C擾
                    FvxVideo1.GetTriggerCycleTime(npMode, dblCycleTime)
                    Me.txtCycleTime.Text = CStr(dblCycleTime)

                    'rfIfoCX̏ԂL
                    m_blnVideoOpened = True
                    cmdGrab.Enabled = True
                    cmdFreerun.Enabled = True

                    'GR[_[h擾
                    'FvxVideo1.GetEncoderParam2(lngSignal, lngZEnb, lngPulse, lngMlt, lngDelayTimeEnb, lngCycleTimeEnb, lngCntEnb, lngMode, lngSwapAB, lngStart, lngComp1, lngComp2, lngInit)
                    FvxVideo1.GetEncoderParam2(lngSignal, lngZEnb, lngPulse, lngMlt, lngDelayTimeEnb, lngCycleTimeEnb, lngCntEnb, lngSwapAB, lngStart, lngComp1, lngComp2, lngInit)
                    'R{{bNXlZbg
                    cboSignal.Items.Clear()
                    cboSignal.Items.Insert(0, "AB")
                    cboSignal.Items.Insert(1, "A")
                    cboSignal.SelectedIndex = lngSignal

                    cboMlt.Items.Clear()
                    cboMlt.Items.Insert(0, "x1")
                    cboMlt.Items.Insert(1, "x2")
                    cboMlt.Items.Insert(2, "x4")
                    cboMlt.SelectedIndex = lngMlt

                    cboStart.Items.Clear()
                    cboStart.Items.Insert(0, "CPU")
                    cboStart.Items.Insert(1, "OgK")
                    cboStart.Items.Insert(2, "ZStart")
                    cboStart.SelectedIndex = lngStart

                    cboPulse.Items.Clear()
                    cboPulse.Items.Insert(0, "CW")
                    cboPulse.Items.Insert(1, "CCW")
                    cboPulse.SelectedIndex = lngPulse

                    txtComp1.Text = CStr(lngComp1)
                    txtComp2.Text = CStr(lngComp2)

                    cboInit.Items.Clear()
                    cboInit.Items.Insert(0, "")
                    cboInit.Items.Insert(1, "Ȃ")
                    cboInit.SelectedIndex = lngInit

                    cboCntEnb.Items.Clear()
                    cboCntEnb.Items.Insert(0, "")
                    cboCntEnb.Items.Insert(1, "")
                    cboCntEnb.Items.Insert(2, "")
                    cboCntEnb.SelectedIndex = lngCntEnb

                    cboMode.Items.Clear()
                    cboMode.Items.Insert(0, "GR[_XL[h")
                    cboMode.Items.Insert(1, "GR[_CI[h")
                    cboMode.SelectedIndex = lngMode

                    cboSwapAB.Items.Clear()
                    cboSwapAB.Items.Insert(0, "A^Bւ")
                    cboSwapAB.Items.Insert(1, "A^BւL")
                    cboSwapAB.SelectedIndex = lngSwapAB

                    cmbTriggerMode.Items.Clear()
                    cmbTriggerMode.Items.Insert(0, "m[}")
                    cmbTriggerMode.Items.Insert(1, "gK")
                    cmbTriggerMode.Items.Insert(2, "OgK1")
                    cmbTriggerMode.Items.Insert(3, "OgK2")
                    cmbTriggerMode.SelectedIndex = lngTrg

                Else
                    MsgBox("FVC07ΉĂ܂BLv`{[hN[Y܂", MsgBoxStyle.Exclamation, "G[")
                    Me.FvxVideo1.CloseDevice()
                End If
            Else
                MsgBox("rfIfoCX̃I[vɎs܂ (" & VB6.Format(lngErr) & ")", MsgBoxStyle.Exclamation, "G[")
            End If

            End If
		
		'ʂ̐
		FvxDisplayEx1.CreateDisplay()
        '摜\
        FvxDisplayEx1.DrawImage(FvxImage1.GetOcx())
		
	End Sub
	
	'EBhETCYύXꂽƂ̏
	'UPGRADE_WARNING: Cxg frmMain.Resize ́AtH[ꂽƂɔ܂B ڍׂɂẮA'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"' NbNĂB
	Private Sub frmMain_Resize(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Resize
		If Me.WindowState <> 1 Then
			FvxDisplayEx1.Width = VB6.TwipsToPixelsX(VB6.PixelsToTwipsX(Me.Width) - VB6.PixelsToTwipsX(FvxDisplayEx1.Left) - 200)
			FvxDisplayEx1.Height = VB6.TwipsToPixelsY(VB6.PixelsToTwipsY(Me.Height) - VB6.PixelsToTwipsY(FvxDisplayEx1.Top) - 600)
		End If
	End Sub
	
	Private Sub frmMain_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		
		Timer1.Enabled = False
		
		If m_blnVideoOpened = True Then
			'rfIfoCXI[vĂꍇ̓N[Y܂
			FvxVideo1.CloseDevice()
		End If
		
	End Sub
	
	'p[^Zbg
	Private Function setParameter() As Boolean
		
		On Error GoTo err_code
		
        'CZT[hݒ
        '2012/5/30 chg
        'FvxVideo1.SetLineSensorMode(chkLineSensorMode.CheckState, chkEncoder.CheckState)
        If chkEncoder.CheckState = 1 Then
            FvxVideo1.SetLineSensorMode(chkLineSensorMode.CheckState, cboMode.SelectedIndex + 1)
        Else
            FvxVideo1.SetLineSensorMode(chkLineSensorMode.CheckState, 0)
        End If

		'GR[_ݒ
        If chkEncoder.CheckState = 1 Then
            '2012/5/30 chg
            'FvxVideo1.SetEncoderParam2(cboSignal.SelectedIndex, cboPulse.SelectedIndex, cboMlt.SelectedIndex, cboCntEnb.SelectedIndex, cboMode.SelectedIndex, cboSwapAB.SelectedIndex, cboStart.SelectedIndex, txtComp1.Text, txtComp2.Text, cboInit.SelectedIndex)
            FvxVideo1.SetEncoderParam2(cboSignal.SelectedIndex, cboPulse.SelectedIndex, cboMlt.SelectedIndex, cboCntEnb.SelectedIndex, cboSwapAB.SelectedIndex, cboStart.SelectedIndex, txtComp1.Text, txtComp2.Text, cboInit.SelectedIndex)
        End If

		'gK[h
		FvxVideo1.SetTrigger(cmbTriggerMode.SelectedIndex)

        'IԐݒ
        FvxVideo1.SetExposureTime(CInt(txtExposureTime.Text))

		'Cݒ
        FvxVideo1.SetTriggerCycleTime(0, CDbl(txtCycleTime.Text))
		
		'摜TCYݒ
        FvxVideo1.ChangeImageSize(FvxImage1.GetOcx())

		'p[^OK
		setParameter = True
		
		Exit Function
		
err_code: 
		
		Dim lngErr As Integer
		FvxVideo1.GetErrReport(lngErr)
		MsgBox("p[^ݒɎs܂B (" & VB6.Format(lngErr) & ")", MsgBoxStyle.Exclamation, "G[")
		setParameter = False
		
	End Function
	
	'J荞
    Private Sub cmdGrab_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdGrab.Click
        Dim dblTime As Double
        Dim lngErr As Integer
        Dim i As Integer

        On Error Resume Next

        'p[^Zbg
        If Not setParameter() Then
            Exit Sub
        End If

        If chkEncoder.CheckState = 1 Then
            If cboCntEnb.SelectedIndex = 1 Then
                '΃GR[_JEgJn
                'ΈʒuGR[_JEgZbg
                FvxVideo1.EncoderClear(2)
            End If
            If cboCntEnb.SelectedIndex = 2 Then
                '΃GR[_JEgJn
                'JE^̃I[o[t[EtO𑦎NA
                FvxVideo1.EncoderClear(0)
                'JE^̃A_[t[EtO𑦎NA
                FvxVideo1.EncoderClear(1)
                'ΈʒuGR[_JEgZbg
                FvxVideo1.EncoderClear(3)
                'ΈʒuGR[_̊Jn
                FvxVideo1.StartAbsEncoder(1)
            End If
        End If

        '捞
        FvxPerformanceCounter1.StartCount() 'ԑJn
        FvxVideo1.GrabSync(FvxImage1.GetOcx())
        FvxPerformanceCounter1.StopCount(dblTime) 'ԑI

        If chkEncoder.CheckState = 1 Then
            If cboCntEnb.SelectedIndex = 2 Then
                '΃GR[_JEg~
                FvxVideo1.StartAbsEncoder(0)
            End If
        End If

        FvxVideo1.GetErrReport(lngErr)

        If lngErr <> 0 Then
            MsgBox("捞G[ (" & VB6.Format(lngErr) & ")", MsgBoxStyle.Exclamation, "G[")
        Else
            '荞񂾉摜ʂɕ\
            FvxDisplayEx1.DrawImage(FvxImage1.GetOcx())
        End If

        txtGrabTime.Text = VB6.Format(dblTime, "0.00ms")

    End Sub
	
	't[JnE~
    Private Sub cmdFreerun_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdFreerun.Click

        'p[^Zbg
        If Not setParameter() Then
            Exit Sub
        End If

        If m_intIsFreerun = 1 Then
            Timer1.Enabled = False
            cmdGrab.Enabled = True
            cmdFreerun.Text = "Freerun"
        Else
            m_time_min = 999999999
            m_time_max = 0
            m_count = 0

            Timer1.Interval = 50
            Timer1.Enabled = True
            cmdGrab.Enabled = False
            cmdFreerun.Text = "Stop"
        End If

        m_intIsFreerun = (m_intIsFreerun + 1) And &H1S

    End Sub
	
	't[
    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick

        Dim dblTime As Double
        Dim lngErr As Integer

        On Error Resume Next

        If m_blnVideoOpened Then
            If chkEncoder.CheckState = 1 Then
                If cboCntEnb.SelectedIndex = 1 Then
                    '΃GR[_JEgJn
                    'ΈʒuGR[_JEgZbg
                    FvxVideo1.EncoderClear(2)
                End If
                If cboCntEnb.SelectedIndex = 2 Then
                    '΃GR[_JEgJn
                    'JE^̃I[o[t[EtO𑦎NA
                    FvxVideo1.EncoderClear(0)
                    'JE^̃A_[t[EtO𑦎NA
                    FvxVideo1.EncoderClear(1)
                    'ΈʒuGR[_JEgZbg
                    FvxVideo1.EncoderClear(3)
                    'ΈʒuGR[_̊Jn
                    FvxVideo1.StartAbsEncoder(1)
                End If
            End If

            FvxPerformanceCounter1.StartCount()
            '捞
            FvxVideo1.GrabSync(FvxImage1.GetOcx())

            FvxPerformanceCounter1.StopCount(dblTime)

            If chkEncoder.CheckState = 1 Then
                If cboCntEnb.SelectedIndex = 2 Then
                    '΃GR[_JEg~
                    FvxVideo1.StartAbsEncoder(0)
                End If
            End If

            FvxVideo1.GetErrReport(lngErr)

            If dblTime < m_time_min Then m_time_min = dblTime
            If m_time_max < dblTime Then m_time_max = dblTime
            m_count = m_count + 1

            If lngErr <> 0 Then
                MsgBox("捞G[ (" & VB6.Format(lngErr) & ")", MsgBoxStyle.Exclamation, "G[")

                Timer1.Enabled = False
            End If

            '摜\
            FvxDisplayEx1.DrawImage(FvxImage1.GetOcx())

            txtGrabTime.Text = VB6.Format(dblTime, "0.00ms")
            lbTimeMin.Text = VB6.Format(m_time_min, "0.00ms")
            lbTimeMax.Text = VB6.Format(m_time_max, "0.00ms")
            lbCount.Text = CStr(CInt(m_count))

            If 1 = chkRandom.CheckState Then
                Sleep(CInt(50 * Rnd()))
            End If
        End If

    End Sub
	
	'\摜ۑ
    Private Sub cmdSaveImage_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSaveImage.Click

        On Error GoTo cmdSaveImage_Click_ErrHandle

        frmFileSave.strPattern = "*.bmp"
        frmFileSave.strDefaultExtension = "bmp"
        frmFileSave.ShowDialog()

        If frmFileSave.strFilePath <> "" Then
            'FileAccessR|[lgg
            'Imaget@Cɕۑ܂
            FvxFileAccess1.FilePath = frmFileSave.strFilePath
            FvxFileAccess1.SaveBitmap(FvxImage1.GetOcx())
        End If

        Exit Sub
cmdSaveImage_Click_ErrHandle:
        MsgBox("ۑɎs܂", MsgBoxStyle.Exclamation, "ۑs")
    End Sub
	
	'rfIݒt@CĐݒ

	
    Private Sub txtComp1_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs)
        Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
        'l̂ݓ͂ł悤ɐ
        'UPGRADE_WARNING: IuWFNg ValueTypeOnly() ̊vpeBł܂łB ڍׂɂẮA'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"' NbNĂB
        KeyAscii = ValueTypeOnly(KeyAscii)
        eventArgs.KeyChar = Chr(KeyAscii)
        If KeyAscii = 0 Then
            eventArgs.Handled = True
        End If
    End Sub
	
    Private Sub txtComp2_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs)
        Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
        'l̂ݓ͂ł悤ɐ
        'UPGRADE_WARNING: IuWFNg ValueTypeOnly() ̊vpeBł܂łB ڍׂɂẮA'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"' NbNĂB
        KeyAscii = ValueTypeOnly(KeyAscii)
        eventArgs.KeyChar = Chr(KeyAscii)
        If KeyAscii = 0 Then
            eventArgs.Handled = True
        End If
    End Sub
	
	Private Sub txtEncInit_KeyPress(ByRef KeyAscii As Short)
		'l̂ݓ͂ł悤ɐ
		'UPGRADE_WARNING: IuWFNg ValueTypeOnly() ̊vpeBł܂łB ڍׂɂẮA'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"' NbNĂB
		KeyAscii = ValueTypeOnly(KeyAscii)
	End Sub
	
    Private Sub txtCycleTime_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs)
        Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
        'l̂ݓ͂ł悤ɐ
        'UPGRADE_WARNING: IuWFNg ValueTypeOnly() ̊vpeBł܂łB ڍׂɂẮA'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"' NbNĂB
        KeyAscii = ValueTypeOnly(KeyAscii)
        eventArgs.KeyChar = Chr(KeyAscii)
        If KeyAscii = 0 Then
            eventArgs.Handled = True
        End If
    End Sub

    'rfIݒt@CĐݒ
    Private Sub cmdResetVideoConfFile_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdResetVideoConfFile.Click
        't[Ȃ΁A~B
        If m_intIsFreerun = 1 Then
            Timer1.Enabled = False
            cmdGrab.Enabled = True
            cmdFreerun.Text = "Freerun"
            m_intIsFreerun = 0
        End If

        'rfIfoCX̑I
        setVideoConfFile()
    End Sub

    '\{plus
    Private Sub cmdDispMinus_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDispMinus.Click
        FvxDisplayEx1.magnification = FvxDisplayEx1.magnification - 0.5
        If FvxDisplayEx1.magnification <= 0.5 Then
            cmdDispMinus.Enabled = False
        Else
            cmdDispMinus.Enabled = True
        End If
        cmdDispPlus.Enabled = True
    End Sub

    '\{minus
    Private Sub cmdDispPlus_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDispPlus.Click
        FvxDisplayEx1.magnification = FvxDisplayEx1.magnification + 0.5
        If FvxDisplayEx1.magnification > 10.0# Then
            cmdDispPlus.Enabled = False
        Else
            cmdDispPlus.Enabled = True
        End If
        cmdDispMinus.Enabled = True
    End Sub

    '{\
    Private Sub cmdDisp1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDisp1.Click
        FvxDisplayEx1.magnification = 1

        cmdDispPlus.Enabled = True
        cmdDispMinus.Enabled = True
    End Sub

    'tʕ\
    Private Sub cmdDispFull_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDispFull.Click
        Dim dblScaleX As Double
        Dim dblScaleY As Double

        dblScaleX = (VB6.PixelsToTwipsX(FvxDisplayEx1.Width) / VB6.TwipsPerPixelX) / FvxImage1.ImageWidth
        dblScaleY = (VB6.PixelsToTwipsY(FvxDisplayEx1.Height) / VB6.TwipsPerPixelY) / FvxImage1.ImageHeight

        If dblScaleX < dblScaleY Then
            FvxDisplayEx1.magnification = dblScaleX
        Else
            FvxDisplayEx1.magnification = dblScaleY
        End If

        cmdDispPlus.Enabled = True
        cmdDispMinus.Enabled = True
    End Sub

    Private Sub txtReceive_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtReceive.TextChanged

    End Sub

    Private Sub Label14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label14.Click

    End Sub
End Class